package de.intevation.flys.importer;

import de.intevation.flys.model.WstColumnValue;
import de.intevation.flys.model.WstColumn;
import de.intevation.flys.model.River;

import java.math.BigDecimal;

import org.hibernate.Session;
import org.hibernate.Query;

import java.util.List;

public class ImportWstColumnValue
{
    protected BigDecimal      position;
    protected BigDecimal      w;
    protected ImportWstColumn wstColumn;

    protected WstColumnValue  peer;

    public ImportWstColumnValue() {
    }

    public ImportWstColumnValue(
        ImportWstColumn wstColumn,
        BigDecimal      position,
        BigDecimal      w
    ) {
        this.wstColumn = wstColumn;
        this.position  = position;
        this.w         = w;
    }

    public BigDecimal getPosition() {
        return position;
    }

    public void setPosition(BigDecimal position) {
        this.position = position;
    }

    public BigDecimal getW() {
        return w;
    }

    public void setW(BigDecimal w) {
        this.w = w;
    }

    public ImportWstColumn getWstColumn() {
        return wstColumn;
    }

    public void setWstColumn(ImportWstColumn wstColumn) {
        this.wstColumn = wstColumn;
    }

    public WstColumnValue getPeer(River river) {
        if (peer == null) {
            WstColumn c = wstColumn.getPeer(river);
            Session session = Importer.sessionHolder.get();
            Query query = session.createQuery(
                "from WstColumnValue where " +
                "wstColumn=:c and position=:p and w=:w");
            query.setParameter("c", c);
            query.setParameter("p", position);
            query.setParameter("w", w);
            List<WstColumnValue> values = query.list();
            if (values.isEmpty()) {
                peer = new WstColumnValue(c, position, w);
                session.save(peer);
            }
            else {
                peer = values.get(0);
            }
        }
        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
